/**
Usage:
Add the snippet below to the end of your "Outgoing sync(data filter)":

replica.key = issue.key

--------------------------------

Add the snippet below to the end of your "Incoming sync for new issues(create processor)":

return CreateIssue.create(
  replica,
  issue,
  relation,
  nodeHelper,
  issueBeforeScript,
  remoteReplica,
  traces,
  blobMetadataList){
   LinkIssuesLocalSync.addLink(
        "Synced from",
        replica,
        issue,
        connection
   )
   return null
}


--------------------------------
 * */
class LinkIssuesLocalSync {
    static com.exalate.basic.domain.hubobject.v1.BasicHubIssue addLink(String theLinkName, com.exalate.basic.domain.hubobject.v1.BasicHubIssue replica, com.exalate.basic.domain.hubobject.v1.BasicHubIssue issue, com.exalate.api.domain.connection.IConnection connection) {
        if (!connection.isLocal()) {
            return issue
        }
        def im = com.atlassian.jira.component.ComponentAccessor.getIssueManager()
        def ilserv = com.atlassian.jira.component.ComponentAccessor.getComponent(com.atlassian.jira.bc.issue.link.IssueLinkService.class)
        def nserv = com.atlassian.jira.component.ComponentAccessor.getOSGiComponentInstanceOfType(com.exalate.api.node.INodeService.class)
        def jIssue = im.getIssueObject(issue.id as Long)
        def localOtherIssue = im.getIssueObject(replica.key)

        if (localOtherIssue == null) {
            return issue
        }
        if (jIssue == null) {
            throw new com.exalate.api.exception.IssueTrackerException(""" 
It seems, that the issue has not been created yet. 
Please open the create processor and ensure that `LinkIssuesLocalSync.receive(...)` is called within `CreateIssue.create(...) {  ... LinkIssuesLocalSync.addLink(...); ... }` (to create the issue and populate the `issue.id` property before using the `LinkIssuesLocalSync.addLink(...)`) """.toString())
        }
        def proxyUser = nserv.getProxyUser()

        def validateAddIssueLinks = { com.atlassian.jira.user.ApplicationUser u, String linkName, String otherIssueKey ->
            try {
                //Jira 7
                ilserv.validateAddIssueLinks(u, jIssue, linkName, [otherIssueKey])
            } catch (Exception ignore) {
                // Jira 6
                //noinspection GroovyAssignabilityCheck
                ilserv.validateAddIssueLinks(u.directoryUser, jIssue, linkName, [otherIssueKey])
            }
        }
        def addIssueLinks = { com.atlassian.jira.user.ApplicationUser u, com.atlassian.jira.bc.issue.link.IssueLinkService.AddIssueLinkValidationResult validationResult ->
            try {
                //Jira 7
                ilserv.addIssueLinks(u, validationResult)
            } catch (Exception ignore) {
                // Jira 6
                //noinspection GroovyAssignabilityCheck
                ilserv.addIssueLinks(u.directoryUser, validationResult)
            }
        }

        com.atlassian.jira.bc.issue.link.IssueLinkService.AddIssueLinkValidationResult addIssueLinkValidationResult = validateAddIssueLinks(proxyUser, theLinkName, replica.key)
        if(addIssueLinkValidationResult.getErrorCollection().hasAnyErrors()) {
            throw new com.exalate.api.exception.IssueTrackerException("Failed to create a link from `${issue.key}` to `${localOtherIssue.key}`. " + com.exalate.util.ErrorCollectionUtils.getFormattedErrorMessage(addIssueLinkValidationResult.getErrorCollection()))
        }

        addIssueLinks(proxyUser, addIssueLinkValidationResult)

        issue
    }
}